Overview | Package | Class | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## com.amazonaws.services.sns
Interface AmazonSNSAsync

All Superinterfaces:
  AmazonSNS

All Known Implementing Classes:
  AmazonSNSAsyncClient

    public interface AmazonSNSAsync

extends AmazonSNS

Interface for accessing AmazonSNS asynchronously, using Java Futures. Amazon Simple Notification Service

Method Summary
`Future<Void>` | `addPermissionAsync(AddPermissionRequest addPermissionRequest)` The AddPermission action adds a statement to a topic's access control policy, granting access for the specified AWS accounts to the specified actions.
`Future<ConfirmSubscriptionResult>` | `confirmSubscriptionAsync(ConfirmSubscriptionRequest confirmSubscriptionRequest)` The ConfirmSubscription action verifies an endpoint owner's intent to receive messages by validating the token sent to the endpoint by an earlier Subscribe action.
`Future<CreateTopicResult>` | `createTopicAsync(CreateTopicRequest createTopicRequest)` The CreateTopic action creates a topic to which notifications can be published.
`Future<Void>` | `deleteTopicAsync(DeleteTopicRequest deleteTopicRequest)` The DeleteTopic action deletes a topic and all its subscriptions.
`Future<GetTopicAttributesResult>` | `getTopicAttributesAsync(GetTopicAttributesRequest getTopicAttributesRequest)` The GetTopicAttribtues action returns all of the properties of a topic customers have created.
`Future<ListSubscriptionsResult>` | `listSubscriptionsAsync(ListSubscriptionsRequest listSubscriptionsRequest)` The ListSubscriptions action returns a list of the requester's subscriptions.
`Future<ListSubscriptionsByTopicResult>` | `listSubscriptionsByTopicAsync(ListSubscriptionsByTopicRequest listSubscriptionsByTopicRequest)` The ListSubscriptionsByTopic action returns a list of the subscriptions to a specific topic.
`Future<ListTopicsResult>` | `listTopicsAsync(ListTopicsRequest listTopicsRequest)` The ListTopics action returns a list of the requester's topics.
`Future<PublishResult>` | `publishAsync(PublishRequest publishRequest)` The Publish action sends a message to all of a topic's subscribed endpoints.
`Future<Void>` | `removePermissionAsync(RemovePermissionRequest removePermissionRequest)` The RemovePermission action removes a statement from a topic's access control policy.
`Future<Void>` | `setTopicAttributesAsync(SetTopicAttributesRequest setTopicAttributesRequest)` The SetTopicAttributes action allows a topic owner to set an attribute of the topic to a new value.
`Future<SubscribeResult>` | `subscribeAsync(SubscribeRequest subscribeRequest)` The Subscribe action prepares to subscribe an endpoint by sending the endpoint a confirmation message.
`Future<Void>` | `unsubscribeAsync(UnsubscribeRequest unsubscribeRequest)` The Unsubscribe action deletes a subscription.

Methods inherited from interface com.amazonaws.services.sns.AmazonSNS
`addPermission, confirmSubscription, createTopic, deleteTopic, getTopicAttributes, listSubscriptions, listSubscriptions, listSubscriptionsByTopic, listTopics, listTopics, publish, removePermission, setEndpoint, setTopicAttributes, shutdown, subscribe, unsubscribe`

Method Detail

### confirmSubscriptionAsync

    Future<ConfirmSubscriptionResult> confirmSubscriptionAsync(ConfirmSubscriptionRequest confirmSubscriptionRequest)
                                                               throws AmazonServiceException,
                                                                      AmazonClientException

  The ConfirmSubscription action verifies an endpoint owner's intent to receive messages by validating the token sent to the endpoint by an earlier Subscribe action. If the token is valid, the action creates a new subscription and returns its Amazon Resource Name (ARN). This call requires an AWS signature only when the AuthenticateOnUnsubscribe flag is set to "true".

  Parameters:
    `confirmSubscriptionRequest` - Container for the necessary parameters to execute the ConfirmSubscription operation on AmazonSNS.
  Returns:
    A Java Future object containing the response from the ConfirmSubscription service method, as returned by AmazonSNS.
  Throws:
    `AmazonClientException` - If any internal errors are encountered inside the client while attempting to make the request or handle the response. For example if a network connection is not available.
    `AmazonServiceException` - If an error response is returned by AmazonSNS indicating either a problem with the data in the request, or a server side issue.

### getTopicAttributesAsync

    Future<GetTopicAttributesResult> getTopicAttributesAsync(GetTopicAttributesRequest getTopicAttributesRequest)
                                                             throws AmazonServiceException,
                                                                    AmazonClientException

  The GetTopicAttribtues action returns all of the properties of a topic customers have created. Topic properties returned might differ based on the authorization of the user.

  Parameters:
    `getTopicAttributesRequest` - Container for the necessary parameters to execute the GetTopicAttributes operation on AmazonSNS.
  Returns:
    A Java Future object containing the response from the GetTopicAttributes service method, as returned by AmazonSNS.
  Throws:
    `AmazonClientException` - If any internal errors are encountered inside the client while attempting to make the request or handle the response. For example if a network connection is not available.
    `AmazonServiceException` - If an error response is returned by AmazonSNS indicating either a problem with the data in the request, or a server side issue.

### subscribeAsync

    Future<SubscribeResult> subscribeAsync(SubscribeRequest subscribeRequest)
                                           throws AmazonServiceException,
                                                  AmazonClientException

  The Subscribe action prepares to subscribe an endpoint by sending the endpoint a confirmation message. To actually create a subscription, the endpoint owner must call the ConfirmSubscription action with the token from the confirmation message. Confirmation tokens are valid for twenty-four hours.

  Parameters:
    `subscribeRequest` - Container for the necessary parameters to execute the Subscribe operation on AmazonSNS.
  Returns:
    A Java Future object containing the response from the Subscribe service method, as returned by AmazonSNS.
  Throws:
    `AmazonClientException` - If any internal errors are encountered inside the client while attempting to make the request or handle the response. For example if a network connection is not available.
    `AmazonServiceException` - If an error response is returned by AmazonSNS indicating either a problem with the data in the request, or a server side issue.

### setTopicAttributesAsync

    Future<Void> setTopicAttributesAsync(SetTopicAttributesRequest setTopicAttributesRequest)
                                         throws AmazonServiceException,
                                                AmazonClientException

  The SetTopicAttributes action allows a topic owner to set an attribute of the topic to a new value.

  Parameters:
    `setTopicAttributesRequest` - Container for the necessary parameters to execute the SetTopicAttributes operation on AmazonSNS.
  Returns:
    A Java Future object containing the response from the SetTopicAttributes service method, as returned by AmazonSNS.
  Throws:
    `AmazonClientException` - If any internal errors are encountered inside the client while attempting to make the request or handle the response. For example if a network connection is not available.
    `AmazonServiceException` - If an error response is returned by AmazonSNS indicating either a problem with the data in the request, or a server side issue.

### deleteTopicAsync

    Future<Void> deleteTopicAsync(DeleteTopicRequest deleteTopicRequest)
                                  throws AmazonServiceException,
                                         AmazonClientException

  The DeleteTopic action deletes a topic and all its subscriptions. Deleting a topic might prevent some messages previously sent to the topic from being delivered to subscribers. This action is idempotent, so deleting a topic that does not exist will not result in an error.

  Parameters:
    `deleteTopicRequest` - Container for the necessary parameters to execute the DeleteTopic operation on AmazonSNS.
  Returns:
    A Java Future object containing the response from the DeleteTopic service method, as returned by AmazonSNS.
  Throws:
    `AmazonClientException` - If any internal errors are encountered inside the client while attempting to make the request or handle the response. For example if a network connection is not available.
    `AmazonServiceException` - If an error response is returned by AmazonSNS indicating either a problem with the data in the request, or a server side issue.

### removePermissionAsync

    Future<Void> removePermissionAsync(RemovePermissionRequest removePermissionRequest)
                                       throws AmazonServiceException,
                                              AmazonClientException

  The RemovePermission action removes a statement from a topic's access control policy.

  Parameters:
    `removePermissionRequest` - Container for the necessary parameters to execute the RemovePermission operation on AmazonSNS.
  Returns:
    A Java Future object containing the response from the RemovePermission service method, as returned by AmazonSNS.
  Throws:
    `AmazonClientException` - If any internal errors are encountered inside the client while attempting to make the request or handle the response. For example if a network connection is not available.
    `AmazonServiceException` - If an error response is returned by AmazonSNS indicating either a problem with the data in the request, or a server side issue.

### listSubscriptionsAsync

    Future<ListSubscriptionsResult> listSubscriptionsAsync(ListSubscriptionsRequest listSubscriptionsRequest)
                                                           throws AmazonServiceException,
                                                                  AmazonClientException

  The ListSubscriptions action returns a list of the requester's subscriptions. Each call returns a limited list of subscriptions. If there are more subscriptions, a NextToken is also returned. Use the NextToken parameter in a new ListSubscriptions call to get further results.

  Parameters:
    `listSubscriptionsRequest` - Container for the necessary parameters to execute the ListSubscriptions operation on AmazonSNS.
  Returns:
    A Java Future object containing the response from the ListSubscriptions service method, as returned by AmazonSNS.
  Throws:
    `AmazonClientException` - If any internal errors are encountered inside the client while attempting to make the request or handle the response. For example if a network connection is not available.
    `AmazonServiceException` - If an error response is returned by AmazonSNS indicating either a problem with the data in the request, or a server side issue.

### addPermissionAsync

    Future<Void> addPermissionAsync(AddPermissionRequest addPermissionRequest)
                                    throws AmazonServiceException,
                                           AmazonClientException

  The AddPermission action adds a statement to a topic's access control policy, granting access for the specified AWS accounts to the specified actions.

  Parameters:
    `addPermissionRequest` - Container for the necessary parameters to execute the AddPermission operation on AmazonSNS.
  Returns:
    A Java Future object containing the response from the AddPermission service method, as returned by AmazonSNS.
  Throws:
    `AmazonClientException` - If any internal errors are encountered inside the client while attempting to make the request or handle the response. For example if a network connection is not available.
    `AmazonServiceException` - If an error response is returned by AmazonSNS indicating either a problem with the data in the request, or a server side issue.

### createTopicAsync

    Future<CreateTopicResult> createTopicAsync(CreateTopicRequest createTopicRequest)
                                               throws AmazonServiceException,
                                                      AmazonClientException

  The CreateTopic action creates a topic to which notifications can be published. Users can create at most 25 topics. This action is idempotent, so if the requester already owns a topic with the specified name, that topic's ARN will be returned without creating a new topic.

  Parameters:
    `createTopicRequest` - Container for the necessary parameters to execute the CreateTopic operation on AmazonSNS.
  Returns:
    A Java Future object containing the response from the CreateTopic service method, as returned by AmazonSNS.
  Throws:
    `AmazonClientException` - If any internal errors are encountered inside the client while attempting to make the request or handle the response. For example if a network connection is not available.
    `AmazonServiceException` - If an error response is returned by AmazonSNS indicating either a problem with the data in the request, or a server side issue.

### listTopicsAsync

    Future<ListTopicsResult> listTopicsAsync(ListTopicsRequest listTopicsRequest)
                                             throws AmazonServiceException,
                                                    AmazonClientException

  The ListTopics action returns a list of the requester's topics. Each call returns a limited list of topics. If there are more topics, a NextToken is also returned. Use the NextToken parameter in a new ListTopics call to get further results.

  Parameters:
    `listTopicsRequest` - Container for the necessary parameters to execute the ListTopics operation on AmazonSNS.
  Returns:
    A Java Future object containing the response from the ListTopics service method, as returned by AmazonSNS.
  Throws:
    `AmazonClientException` - If any internal errors are encountered inside the client while attempting to make the request or handle the response. For example if a network connection is not available.
    `AmazonServiceException` - If an error response is returned by AmazonSNS indicating either a problem with the data in the request, or a server side issue.

### unsubscribeAsync

    Future<Void> unsubscribeAsync(UnsubscribeRequest unsubscribeRequest)
                                  throws AmazonServiceException,
                                         AmazonClientException

  The Unsubscribe action deletes a subscription. If the subscription requires authentication for deletion, only the owner of the subscription or the its topic's owner can unsubscribe, and an AWS signature is required. If the Unsubscribe call does not require authentication and the requester is not the subscription owner, a final cancellation message is delivered to the endpoint, so that the endpoint owner can easily resubscribe to the topic if the Unsubscribe request was unintended.

  Parameters:
    `unsubscribeRequest` - Container for the necessary parameters to execute the Unsubscribe operation on AmazonSNS.
  Returns:
    A Java Future object containing the response from the Unsubscribe service method, as returned by AmazonSNS.
  Throws:
    `AmazonClientException` - If any internal errors are encountered inside the client while attempting to make the request or handle the response. For example if a network connection is not available.
    `AmazonServiceException` - If an error response is returned by AmazonSNS indicating either a problem with the data in the request, or a server side issue.

### listSubscriptionsByTopicAsync

    Future<ListSubscriptionsByTopicResult> listSubscriptionsByTopicAsync(ListSubscriptionsByTopicRequest listSubscriptionsByTopicRequest)
                                                                         throws AmazonServiceException,
                                                                                AmazonClientException

  The ListSubscriptionsByTopic action returns a list of the subscriptions to a specific topic. Each call returns a limited list of subscriptions. If there are more subscriptions, a NextToken is also returned. Use the NextToken parameter in a new ListSubscriptionsByTopic call to get further results.

  Parameters:
    `listSubscriptionsByTopicRequest` - Container for the necessary parameters to execute the ListSubscriptionsByTopic operation on AmazonSNS.
  Returns:
    A Java Future object containing the response from the ListSubscriptionsByTopic service method, as returned by AmazonSNS.
  Throws:
    `AmazonClientException` - If any internal errors are encountered inside the client while attempting to make the request or handle the response. For example if a network connection is not available.
    `AmazonServiceException` - If an error response is returned by AmazonSNS indicating either a problem with the data in the request, or a server side issue.

### publishAsync

    Future<PublishResult> publishAsync(PublishRequest publishRequest)
                                       throws AmazonServiceException,
                                              AmazonClientException

  The Publish action sends a message to all of a topic's subscribed endpoints. When a messageId is returned, the message has been saved and Amazon SNS will attempt to deliver it to the topic's subscribers shortly. The format of the outgoing message to each subscribed endpoint depends on the notification protocol selected.

  Parameters:
    `publishRequest` - Container for the necessary parameters to execute the Publish operation on AmazonSNS.
  Returns:
    A Java Future object containing the response from the Publish service method, as returned by AmazonSNS.
  Throws:
    `AmazonClientException` - If any internal errors are encountered inside the client while attempting to make the request or handle the response. For example if a network connection is not available.
    `AmazonServiceException` - If an error response is returned by AmazonSNS indicating either a problem with the data in the request, or a server side issue.

Overview | Package | Class | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2010 Amazon Web Services, Inc. All Rights Reserved.